;copyright 2003 by Samuel Stearley



	include 	"os.h"
	xdef		_nostub
	xdef		_ti89
	xdef		_ti92plus



_main:
	movem.l	d0-d7/a0-a6,-(a7)
	move.l	200,a5
	move.l	1060(a5),a4
	move.l	(a4),a0		;top_estack

	bsr		MyArgumentCount
	subq.w	#4,d0
	bcc		ExitError
	move.l	(a4),a0
	bsr		MyNextExprIndex	;skip over list

;----read in row----

	moveq		#0,d3
	cmp.b		#$e5,(a0)
	beq		SkipColumnReading
	cmp.b		#$1f,(a0)
	bne		ExitError
	move.b	-(a0),d0	;get the size
	beq		ExitError
	move.b	-(a0),d3
	subq.b	#1,d0
	beq		HaveIt
	lsl.w		#8,d3
	move.b	-(a0),d3
	subq.b	#1,d0
	bne		ExitError
HaveIt:
	subq.l	#1,a0

;----read in column------

	moveq		#0,d4
	cmp.b		#$e5,(a0)
	beq		SkipColumnReading
	cmp.b		#$1f,(a0)
	bne		ExitError
	move.b	-(a0),d0	;get the sixe
	beq		ExitError
	move.b	-(a0),d4
	subq.b	#1,d0
	beq		HaveIt22
	lsl.w		#8,d3
	move.b	-(a0),d4
	subq.b	#1,d0
	bne		ExitError
HaveIt22:
	subq.l	#1,a0
SkipColumnReading:
	subq.l	#1,a0
	move.l	(a4),d0
	move.l	a0,(a4)	;modify top_estack

;----If it is a list go normal, else if string do a vat-search----

	move.l	d0,a0
	cmp.b		#$D9,(a0)		;list?
	beq		IsList
	cmp.b		#$2d,(a0)		;string?
	bne		ExitError

;---find it----

	pea		-1(a0)
	move.l	384(a5),a0
	jsr		(a0)			;find it
	addq.l	#4,a7
	tst.l		d0
	beq		ExitError		;if it does not exist
	move.l	d0,-(a7)
	move.l	484(a5),a0
	jsr		(a0)			;dereference the hsym
	move.w	$C(a0),(a7)		;get handle
	move.l	2332(a5),a0
	jsr		(a0)
	addq.l	#4,a7
	cmp.b		#$D9,(a0)
	bne		ExitError

IsList:
	tst.w		d3
	bne		NoWantSize

;---They just want the size of the list/matrix----

	moveq		#0,d7
	cmp.b		#$D9,-(a0)		;matrix?
	bne		NotAMat
	moveq		#1,d7
	move.l	a0,a3
	bsr		MyArgumentCount	;count rows
	lea		-1(a3),a0
	move.w	d0,d3
NotAMat:
	bsr		MyArgumentCount	;count list elements/columns
	move.l	d0,d4

;---d7 is 0 if list, else a matrix
;---If a matrix d3 has # of rows while d4 has # of collumns
;---If a list then d4 has number of element

	move.l	(a4),a0
	addq.l	#1,a0
	tst.b		d7
	beq		SkipRows
	exg		d3,d4
	move.b	#$e5,(a0)+
	move.l	d3,d0
	bsr		PushInt
SkipRows:
	move.l	d4,d0
	bsr		PushInt
	tst.b		d7
	beq		SkipEndTag
	move.b	#$d9,(a0)+
SkipEndTag:
	subq.l	#1,a0
	move.l	a0,(a4)
	bra		ReturnValue

;---So the user is trying to extract an element or row?

NoWantSize:
	tst.w		d4			;3 arguments?
	beq		SkipMatrixCheck
	cmp.b		#$D9,-1(a0)
	bne		ExitError

;----Get the correct row----

SkipMatrixCheck:
	subq.l	#1,a0
	subq.w	#1,d3
	bra		IntoRowLoop
RowLoop:
	bsr		MyNextExprIndex
	cmp.b		#$E5,(a0)
	beq		ExitError		;dimension error!
IntoRowLoop:
	dbra		d3,RowLoop

;----Get the correct column----

	subq.w	#1,d4
	bcs		ReturnEsiA0
	subq.l	#1,a0
	bra		IntoColLoop
ColLoop:
	bsr		MyNextExprIndex
	cmp.b		#$E5,(a0)
	beq		ExitError		;dimension error!
IntoColLoop:
	dbra		d4,ColLoop

;----A0 now has esi of it----

ReturnEsiA0:
	move.l	a0,-(a7)
	bsr		MyNextExprIndex
	move.l	a0,-(a7)
	move.l	2976(a5),a0
	jsr		(a0)			;pushed it!
	addq.l	#8,a7

ReturnValue:
	movem.l	(a7)+,d0-d7/a0-a6
	move.l	(a7)+,a0		;get the return address, this is part of the
	cmpi.w	#$21EE,(a0)		;  return value hack.
	bne.s		__A2
	addq.l	#2,a0
__A2:
	jmp		4(a0)

;----Return normally----

ExitError:
	movem.l	(a7)+,d0-d7/a0-a6
	rts


;---Inputs-----------------
;d0.w the int
;a0 points to place to store it
;--------------------------
PushInt:
	moveq		#0,d1		;size
	tst.w		d0
	beq		Skip
	addq.b	#1,d1
	move.b	d0,(a0)+
	lsr.w		#8,d0
	beq		Skip
	addq.b	#1,d1
	move.b	d0,(a0)+
Skip:
	move.b	d1,(a0)+
	move.b	#$1f,(a0)+
	rts



	include 	"next.asm"
