;Copyright 2002 by Samuel Stearley



MyArgumentCount:
	move.l	d7,-(a7)
	moveq		#0,d7
__CountArgLoop:
	cmp.b		#$E5,(a0)
	beq		__ReturnCount
	addq.l	#1,d7
	bsr		MyNextExprIndex
	bra		__CountArgLoop
__ReturnCount:
	move.w	d7,d0
	move.l	(a7)+,d7
	rts


MyNextExprIndex:
	movem.l	a2-a4,-(a7)

;---Initiate variables-----

	moveq		#0,d0				;d0 will have bytes moved into it,
							;  but it will be used as longs or words
	moveq		#0,d1				;number of tags we have hit that need to be
							;  closed by an end_list_tag, but have not
							;  yet been closed.
	lea		__JumpPoint(pc),a2	;a special point for looping, like a return address
	move.l	a2,a4
	lea		__GoTillEnd(pc),a3
	lea		__DataDescribingJumpTable(pc),a1
	moveq		#1,d2
	move.b	(a0),d0			;get the first tag
	bra.s		__IntoLoop			;and off to wallah land

;---The Primary loop---

__OnlyNeedToAdd:
	add.w		d0,d2
__JumpPoint:					;the "return address" in a2 points here
	subq.w	#1,d2
	beq.s		__DoneDecing
	move.b	-(a0),d0			;get tag
__IntoLoop:
	move.b	0(a1,d0),d0			;get the argument data
	bpl.s		__OnlyNeedToAdd
	add.b		d0,d0				;use the jump table to handle this one
	jmp		10(pc,d0)

__DoneDecing:
	subq.l	#1,a0
	movem.l	(a7)+,a2-a4
	rts

;For this to work the following code can not exceed 255 bytes
;Actually that mean 254 bytes

;They all expect a pointer to thier own tag
;and they return a pointer to the last byte of themselves
;(so a predecriment can grab the next tag)

__Base:
__EndTagTerminated:
	addq.w	#1,d1			;keep track of number of them we've hit
	move.l	a3,a2			;load our "return address"

;----The loop for expressions that are terminated by the
;----end tag.

__GoTillEnd:				;a second  "return address"
	move.b	-(a0),d0
	move.b	0(a1,d0),d0		;test the argument describer
	bpl.s		__GoTillEnd		;if negative then we use a jump table
	add.b		d0,d0			;clear out sign bit and double lower bits
	jmp		-16(pc,d0)
__EndTag:
	subq.w	#1,d1			;decrease number of unclosed functions
	bne.s		__GoTillEnd		
	move.l	a4,a2
	jmp		(a2)
__SystemTag:
__ArbRealTag:
__ArbIntTag:
	subq.l	#1,a0
	jmp		(a2)
__PosFracTag:
__NegFracTag:
	move.b	-(a0),d0
	sub.l		d0,a0
__PosIntTag:
__NegIntTag:
	move.b	-(a0),d0
	sub.l		d0,a0
	jmp		(a2)
__FloatTag:
	lea		-9(a0),a0
	jmp		(a2)
__StringTag:
__NameTag:
	subq.l	#1,a0
__DecLoop:
	tst.b		-(a0)
	beq.s		__FarEnough		;short branches are faster if not taken
	tst.b		-(a0)
	beq.s		__FarEnough
	tst.b		-(a0)
	beq.s		__FarEnough
	tst.b		-(a0)
	beq.s		__FarEnough
	tst.b		-(a0)
	beq.s		__FarEnough
	tst.b		-(a0)
	beq.s		__FarEnough
	tst.b		-(a0)
	beq.s		__FarEnough
	tst.b		-(a0)
	bne.s		__DecLoop
__FarEnough:
	jmp		(a2)

;-----The following table is a combination data describing table and an
;-----actual jump table.  If high bit is set then use the jump table, the lower bits
;-----will be doubled to create the index into the above code, this also performs the
;-----function of clearing out that upper bit.
;
;-----If high bit is clear then the low bits dictate how many arguments the function
;-----takes.  Note that one letter variables can be considered zero argument functions.


__DataDescribingJumpTable:
	dc.b		(__NameTag-__Base)/2+128			;tag 0
	dc.b		0		;q
	dc.b		0		;r
	dc.b		0		;s
	dc.b		0		;t
	dc.b		0		;u
	dc.b		0		;v
	dc.b		0		;w
	dc.b		0		;x
	dc.b		0		;y
	dc.b		0		;z
	dc.b		0		;a
	dc.b		0		;b
	dc.b		0		;c
	dc.b		0		;d
	dc.b		0		;e
	dc.b		0		;f
	dc.b		0		;g
	dc.b		0		;h
	dc.b		0		;i
	dc.b		0		;j
	dc.b		0		;k
	dc.b		0		;l
	dc.b		0		;m
	dc.b		0		;n
	dc.b		0		;o
	dc.b		0		;p
	dc.b		0		;q again
	dc.b		(__SystemTag-__Base)/2+128
	dc.b		(__ArbRealTag-__Base)/2+128
	dc.b		(__ArbIntTag-__Base)/2+128
	dc.b		(__PosIntTag-__Base)/2+128
	dc.b		(__NegIntTag-__Base)/2+128
	dc.b		(__PosFracTag-__Base)/2+128
	dc.b		(__NegFracTag-__Base)/2+128
	dc.b		(__FloatTag-__Base)/2+128
	dc.b		0		;Pi
	dc.b		0		;E
	dc.b		0		;i
	dc.b		0		;neg infinity
	dc.b		0		;pos infinity
	dc.b		0		;pos/neg infinity
	dc.b		0		;undefinde
	dc.b		0		;false
	dc.b		0		;true
	dc.b		(__StringTag-__Base)/2+128
	dc.b		0		;the "place holder" expression, 0x2E

;----1 argument functions-----
	
	dc.b		1		;2F cosh
	dc.b		1		;30
	dc.b		1		;31
	dc.b		1		;32
	dc.b		1		;33
	dc.b		1		;34
	dc.b		1		;35
	dc.b		1		;36
	dc.b		1		;37
	dc.b		1		;38
	dc.b		1		;39
	dc.b		1		;3a
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1		;3e
	dc.b		1		;3f
	dc.b		1		;40
	dc.b		1		;arcosine internal
	dc.b		1		;arsine internal
	dc.b		1		;arc tan internal
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1		;47	SECANT
	dc.b		1		;48
	dc.b		1		;49
	dc.b		1		;internal tan
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1

	dc.b		0		;5f

	dc.b		1		;60
	dc.b		1		;61 is det 1 arg version
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1
	dc.b		1			;various vectors. previous they where 3
	dc.b		1
	dc.b		1
	dc.b		0			;start tag internal

;----Begin Two argument Tags----

	dc.b		2			;internal store
	dc.b		2			;store
	dc.b		2			;with
	dc.b		2			;xor
	dc.b		2			;or
	dc.b		2			;and
	dc.b		2			;lt
	dc.b		2			;le
	dc.b		2			;eq
	dc.b		2			;ge
	dc.b		2			;gt
	dc.b		2			;ne
	dc.b		2			;add
	dc.b		2			;dot add
	dc.b		2			;sub
	dc.b		2			;dot sub
	dc.b		2			;multiply
	dc.b		2			;dot multiply
	dc.b		2			;divide
	dc.b		2			;dot divide
	dc.b		2			;power
	dc.b		2			;dot power
	dc.b		2			;SinCosTag,	Internal
	dc.b		2
	dc.b		2
	dc.b		2
	dc.b		2
	dc.b		2
	dc.b		2
	dc.b		2
	dc.b		2			;ComplexTag, Internal
	dc.b		2
	dc.b		2
	dc.b		2
	dc.b		2
	dc.b		2
	dc.b		2
	dc.b		2
	dc.b		2
	dc.b		2
	dc.b		2
	dc.b		2
	dc.b		2
	dc.b		2
	dc.b		2
	dc.b		2
	dc.b		2
	dc.b		2
	dc.b		2
	dc.b		2
	dc.b		(__EndTagTerminated-__Base)/2+128	;the part tag
	dc.b		2
	dc.b		2

;---3 argument tags
;---tios actually encodes them as variable argument functions

	dc.b		(__EndTagTerminated-__Base)/2+128		;mrow
	dc.b		(__EndTagTerminated-__Base)/2+128		;row add
	dc.b		(__EndTagTerminated-__Base)/2+128		;row swap

;---4 argument tags
;---tios actually encodes them as variable argument functions

	dc.b		(__EndTagTerminated-__Base)/2+128		;arclength
	dc.b		(__EndTagTerminated-__Base)/2+128		;n Int
	dc.b		(__EndTagTerminated-__Base)/2+128		;Pi Product
	dc.b		(__EndTagTerminated-__Base)/2+128		;Sigma Sum
	dc.b		(__EndTagTerminated-__Base)/2+128		;M row add

;---Variable number of arguments-----

	dc.b		(__EndTagTerminated-__Base)/2+128		;ans
	dc.b		(__EndTagTerminated-__Base)/2+128		;entry
	dc.b		(__EndTagTerminated-__Base)/2+128
	dc.b		0							;logb tag
	dc.b		(__EndTagTerminated-__Base)/2+128
	dc.b		(__EndTagTerminated-__Base)/2+128
	dc.b		(__EndTagTerminated-__Base)/2+128
	dc.b		(__EndTagTerminated-__Base)/2+128
	dc.b		(__EndTagTerminated-__Base)/2+128
	dc.b		(__EndTagTerminated-__Base)/2+128
	dc.b		(__EndTagTerminated-__Base)/2+128
	dc.b		(__EndTagTerminated-__Base)/2+128
	dc.b		(__EndTagTerminated-__Base)/2+128
	dc.b		(__EndTagTerminated-__Base)/2+128
	dc.b		(__EndTagTerminated-__Base)/2+128
	dc.b		(__EndTagTerminated-__Base)/2+128		;0xCB
	dc.b		(__EndTagTerminated-__Base)/2+128		;0xCC
	dc.b		(__EndTagTerminated-__Base)/2+128		;0xCD
	dc.b		(__EndTagTerminated-__Base)/2+128		;0xCE
	dc.b		(__EndTagTerminated-__Base)/2+128		;0xCF
	dc.b		(__EndTagTerminated-__Base)/2+128		;0xD0
	dc.b		(__EndTagTerminated-__Base)/2+128		;0xD1
	dc.b		(__EndTagTerminated-__Base)/2+128		;0xD2
	dc.b		(__EndTagTerminated-__Base)/2+128		;0xD3
	dc.b		(__EndTagTerminated-__Base)/2+128		;0xD4
	dc.b		(__EndTagTerminated-__Base)/2+128		;subscript D5
	dc.b		(__EndTagTerminated-__Base)/2+128		;D6
	dc.b		(__EndTagTerminated-__Base)/2+128		;min tag D7
	dc.b		(__EndTagTerminated-__Base)/2+128		;max tag D8
	dc.b		(__EndTagTerminated-__Base)/2+128		;ListTag D9
	dc.b		(__EndTagTerminated-__Base)/2+128		;UserfuncTag
	dc.b		0							;matrix tag not used
	dc.b		0							;func tag
	dc.b		0							;data tag
	dc.b		0							;gdb tag
	dc.b		0							;pic tag
	dc.b		0							;text tag
	dc.b		0							;figure tag
	dc.b		0							;macro tag
	dc.b		0							;extra tag tokens
	dc.b		0							;ti-basic commands
	dc.b		(__EndTag-__Base)/2+128			;End tag
	dc.b		0							;comment tag
	dc.b		0							;next expression tag
	dc.b		0							;new line
	dc.b		0							;end of estack. E9
	dc.b		1							;plus or minus 1
	dc.b		2							;plus or minus2
	dc.b		0							;error message tag
	dc.b		1							;eigvc
	dc.b		1							;eigvl
	dc.b		1							;prime x'
	dc.b		1							;local var tag
	dc.b		(__EndTag-__Base)/2+128			;desolve
	dc.b		1							;fdash tag f'(x)
	dc.b		0							;asm tag
	dc.b		1							;is prime, why placed here?
	dc.b		0							;f5
	dc.b		0							;f6
	dc.b		0							;f7
	dc.b		0							;other tag
	dc.b		(__EndTag-__Base)/2+128
	dc.b		0							;fa
	dc.b		0							;fb
	dc.b		0							;fc
	dc.b		0							;fd
	dc.b		0							;fe
	dc.b		0							;ff
